#version 430 core
layout (location = 0) in vec3 pos;
layout (location = 1) in vec3 normal;
layout (location = 2) in vec2 texCoords;
layout (location = 3) in mat4 aInstanceMatrix;

 
out vec4 fragPosLightSpace;



out vec2 TexCoords;
out vec3 fragPosition;
out vec3 Normal;

uniform mat4 modelMatrix;
uniform mat4 projectionMatrix;
uniform mat4 projectionView;
uniform mat4 lightSpaceMatrix;
uniform bool particle;
uniform mat4 movingMatrix;



void main()
{
	if(!particle) {
		gl_Position = projectionMatrix  * modelMatrix * vec4(pos,1);
	}
	else {
		gl_Position = projectionView * aInstanceMatrix * movingMatrix * vec4(pos, 1.0f); 
	}
    fragPosition = vec3(modelMatrix * vec4(pos, 1.0f));
    Normal = mat3(transpose(inverse(modelMatrix))) * normal;
    TexCoords = texCoords;
	fragPosLightSpace = lightSpaceMatrix * vec4(fragPosition, 1.0);
}