#version 410 core
in vec3 TexCoords;
out vec4 color;

uniform samplerCube skybox;
uniform float gamma;

const float levels = 10.0;
vec3 c = vec3(0.041,0.228,0.912);


void main()
{    
	
    vec4 tex = texture(skybox, TexCoords);
	float amount = (tex.r+tex.g+tex.b)/3.0;
	amount = floor(amount * levels)/levels;
	tex.rgb = amount * c;
	
	color = mix(vec4(c,1.0),tex,0.9);

	//color = texture(skybox, TexCoords);
	
	color.rgb = pow(color.rgb, vec3(1.0/gamma));
}
  